<?php
/**
 * Chat
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\InternalMessenger
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi. Internal messenger. Внутренние чаты
 *
 * Управление внутренними чатами
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\InternalMessenger\Dto;

use \ArrayAccess;
use \Ensi\InternalMessenger\ObjectSerializer;

/**
 * Chat Class Doc Comment
 *
 * @category Class
 * @package  Ensi\InternalMessenger
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class Chat implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'Chat';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'user_id' => 'int',
        'user_type' => 'int',
        'direction' => 'int',
        'type_id' => 'int',
        'theme' => 'string',
        'muted' => 'bool',
        'unread_user' => 'bool',
        'unread_admin' => 'bool',
        'messages' => '\Ensi\InternalMessenger\Dto\Message[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'id' => null,
        'user_id' => null,
        'user_type' => null,
        'direction' => null,
        'type_id' => null,
        'theme' => null,
        'muted' => null,
        'unread_user' => null,
        'unread_admin' => null,
        'messages' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'id' => false,
        'user_id' => false,
        'user_type' => false,
        'direction' => false,
        'type_id' => false,
        'theme' => false,
        'muted' => false,
        'unread_user' => false,
        'unread_admin' => false,
        'messages' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::openAPINullables()[$property])) {
            return self::openAPINullables()[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'user_id' => 'user_id',
        'user_type' => 'user_type',
        'direction' => 'direction',
        'type_id' => 'type_id',
        'theme' => 'theme',
        'muted' => 'muted',
        'unread_user' => 'unread_user',
        'unread_admin' => 'unread_admin',
        'messages' => 'messages'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'user_id' => 'setUserId',
        'user_type' => 'setUserType',
        'direction' => 'setDirection',
        'type_id' => 'setTypeId',
        'theme' => 'setTheme',
        'muted' => 'setMuted',
        'unread_user' => 'setUnreadUser',
        'unread_admin' => 'setUnreadAdmin',
        'messages' => 'setMessages'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'user_id' => 'getUserId',
        'user_type' => 'getUserType',
        'direction' => 'getDirection',
        'type_id' => 'getTypeId',
        'theme' => 'getTheme',
        'muted' => 'getMuted',
        'unread_user' => 'getUnreadUser',
        'unread_admin' => 'getUnreadAdmin',
        'messages' => 'getMessages'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('id', $data, null);
        $this->setIfExists('user_id', $data, null);
        $this->setIfExists('user_type', $data, null);
        $this->setIfExists('direction', $data, null);
        $this->setIfExists('type_id', $data, null);
        $this->setIfExists('theme', $data, null);
        $this->setIfExists('muted', $data, null);
        $this->setIfExists('unread_user', $data, null);
        $this->setIfExists('unread_admin', $data, null);
        $this->setIfExists('messages', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['id'] === null) {
            $invalidProperties[] = "'id' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int $id Идентификатор чата
     *
     * @return $this
     */
    public function setId($id)
    {


        /*if (is_null($id)) {
            throw new \InvalidArgumentException('non-nullable id cannot be null');
        }*/
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets user_id
     *
     * @return int|null
     */
    public function getUserId()
    {
        return $this->container['user_id'];
    }

    /**
     * Sets user_id
     *
     * @param int|null $user_id Идентификатор пользователя
     *
     * @return $this
     */
    public function setUserId($user_id)
    {


        /*if (is_null($user_id)) {
            throw new \InvalidArgumentException('non-nullable user_id cannot be null');
        }*/
        $this->container['user_id'] = $user_id;

        return $this;
    }

    /**
     * Gets user_type
     *
     * @return int|null
     */
    public function getUserType()
    {
        return $this->container['user_type'];
    }

    /**
     * Sets user_type
     *
     * @param int|null $user_type Тип пользователя
     *
     * @return $this
     */
    public function setUserType($user_type)
    {


        /*if (is_null($user_type)) {
            throw new \InvalidArgumentException('non-nullable user_type cannot be null');
        }*/
        $this->container['user_type'] = $user_type;

        return $this;
    }

    /**
     * Gets direction
     *
     * @return int|null
     */
    public function getDirection()
    {
        return $this->container['direction'];
    }

    /**
     * Sets direction
     *
     * @param int|null $direction Направление чата
     *
     * @return $this
     */
    public function setDirection($direction)
    {


        /*if (is_null($direction)) {
            throw new \InvalidArgumentException('non-nullable direction cannot be null');
        }*/
        $this->container['direction'] = $direction;

        return $this;
    }

    /**
     * Gets type_id
     *
     * @return int|null
     */
    public function getTypeId()
    {
        return $this->container['type_id'];
    }

    /**
     * Sets type_id
     *
     * @param int|null $type_id Тип чата
     *
     * @return $this
     */
    public function setTypeId($type_id)
    {


        /*if (is_null($type_id)) {
            throw new \InvalidArgumentException('non-nullable type_id cannot be null');
        }*/
        $this->container['type_id'] = $type_id;

        return $this;
    }

    /**
     * Gets theme
     *
     * @return string|null
     */
    public function getTheme()
    {
        return $this->container['theme'];
    }

    /**
     * Sets theme
     *
     * @param string|null $theme Тема чата
     *
     * @return $this
     */
    public function setTheme($theme)
    {


        /*if (is_null($theme)) {
            throw new \InvalidArgumentException('non-nullable theme cannot be null');
        }*/
        $this->container['theme'] = $theme;

        return $this;
    }

    /**
     * Gets muted
     *
     * @return bool|null
     */
    public function getMuted()
    {
        return $this->container['muted'];
    }

    /**
     * Sets muted
     *
     * @param bool|null $muted Флаг чата без ответов
     *
     * @return $this
     */
    public function setMuted($muted)
    {


        /*if (is_null($muted)) {
            throw new \InvalidArgumentException('non-nullable muted cannot be null');
        }*/
        $this->container['muted'] = $muted;

        return $this;
    }

    /**
     * Gets unread_user
     *
     * @return bool|null
     */
    public function getUnreadUser()
    {
        return $this->container['unread_user'];
    }

    /**
     * Sets unread_user
     *
     * @param bool|null $unread_user Флаг непрочтении юзером
     *
     * @return $this
     */
    public function setUnreadUser($unread_user)
    {


        /*if (is_null($unread_user)) {
            throw new \InvalidArgumentException('non-nullable unread_user cannot be null');
        }*/
        $this->container['unread_user'] = $unread_user;

        return $this;
    }

    /**
     * Gets unread_admin
     *
     * @return bool|null
     */
    public function getUnreadAdmin()
    {
        return $this->container['unread_admin'];
    }

    /**
     * Sets unread_admin
     *
     * @param bool|null $unread_admin Флаг непрочтении админом
     *
     * @return $this
     */
    public function setUnreadAdmin($unread_admin)
    {


        /*if (is_null($unread_admin)) {
            throw new \InvalidArgumentException('non-nullable unread_admin cannot be null');
        }*/
        $this->container['unread_admin'] = $unread_admin;

        return $this;
    }

    /**
     * Gets messages
     *
     * @return \Ensi\InternalMessenger\Dto\Message[]|null
     */
    public function getMessages()
    {
        return $this->container['messages'];
    }

    /**
     * Sets messages
     *
     * @param \Ensi\InternalMessenger\Dto\Message[]|null $messages messages
     *
     * @return $this
     */
    public function setMessages($messages)
    {


        /*if (is_null($messages)) {
            throw new \InvalidArgumentException('non-nullable messages cannot be null');
        }*/
        $this->container['messages'] = $messages;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset): mixed
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }

    /**
    * Convert object to array
    *
    * @return array
    */
    public function toArray()
    {
        return json_decode(json_encode(ObjectSerializer::sanitizeForSerialization($this)), true);
    }
}


